Index: trunk/FACT++/dim/src/dtq.c
===================================================================
--- trunk/FACT++/dim/src/dtq.c	(revision 14939)
+++ trunk/FACT++/dim/src/dtq.c	(revision 15282)
@@ -10,4 +10,11 @@
 
 /* include files */
+#ifndef WIN32
+#ifndef NOTHREADS
+int DIM_Threads_OFF = 0;
+#else
+int DIM_Threads_OFF = 1;
+#endif
+#endif
 #include <signal.h>
 #include <stdio.h>
@@ -76,4 +83,5 @@
 	extern void dis_no_threads();
 	
+	DIM_Threads_OFF = 1;
 	Threads_off = 1;
 	dic_no_threads();
@@ -231,6 +239,6 @@
 	tz = 0;
 	gettimeofday(&tv, tz);
-	secs = tv.tv_sec;
-	*millies = tv.tv_usec / 1000;
+	secs = (int)tv.tv_sec;
+	*millies = (int)tv.tv_usec / 1000;
 #endif
 	return secs;
@@ -266,5 +274,5 @@
 		else
 		{
-			return(alarm(secs));
+			return((int)alarm((unsigned int)secs));
 		}
 	}
Index: trunk/FACT++/dim/src/examples/demo_client.c
===================================================================
--- trunk/FACT++/dim/src/examples/demo_client.c	(revision 14939)
+++ trunk/FACT++/dim/src/examples/demo_client.c	(revision 15282)
@@ -30,5 +30,5 @@
 		scanf("%s",cmnd);
 		printf("Sending Command: %s\n",cmnd);
-		dic_cmnd_service(aux,cmnd,strlen(cmnd)+1);
+		dic_cmnd_service(aux,cmnd,(int)strlen(cmnd)+1);
 	}
 }
Index: trunk/FACT++/dim/src/examples/pvss_dim_server.cxx
===================================================================
--- trunk/FACT++/dim/src/examples/pvss_dim_server.cxx	(revision 14939)
+++ trunk/FACT++/dim/src/examples/pvss_dim_server.cxx	(revision 15282)
@@ -227,5 +227,5 @@
 //		simpleService.updateService();
 
-		if(strlen(cData.str) < 16)
+		if((int)strlen(cData.str) < 16)
 			strcat(cData.str," abc");
 		cTestService.updateService();
Index: trunk/FACT++/dim/src/examples/rpc_server.cxx
===================================================================
--- trunk/FACT++/dim/src/examples/rpc_server.cxx	(revision 14939)
+++ trunk/FACT++/dim/src/examples/rpc_server.cxx	(revision 15282)
@@ -72,5 +72,5 @@
 		pout.c1 = pin->c1;
 		strcpy(pout.str,pin->str);
-		setData(&pout, strlen(pout.str)+1+5);
+		setData(&pout, (int)strlen(pout.str)+1+5);
 	}
 public:
Index: trunk/FACT++/dim/src/examples/test_client.c
===================================================================
--- trunk/FACT++/dim/src/examples/test_client.c	(revision 14939)
+++ trunk/FACT++/dim/src/examples/test_client.c	(revision 15282)
@@ -83,5 +83,5 @@
 		printf("DNS node = %s\n",node);
 		printf("size = %d\n",*size);
-		memcpy(&t, buf, *size);
+		memcpy(&t, buf, (size_t)*size);
 		printf("t.i = %d, t.d = %2.2f, t.s = %d, t.c = %c, t.f = %2.2f, t.str = %s\n",
 			t.i,t.d,t.s,t.c,t.f,t.str);
@@ -89,5 +89,5 @@
 		tsecs = secs;
 		my_ctime(&tsecs, str, 128);
-		str[strlen(str)-1] = '\0';
+		str[(int)strlen(str)-1] = '\0';
 		printf("timestamp = %s.%d\n",str,millis);
 
Index: trunk/FACT++/dim/src/examples/test_server.c
===================================================================
--- trunk/FACT++/dim/src/examples/test_server.c	(revision 14939)
+++ trunk/FACT++/dim/src/examples/test_server.c	(revision 15282)
@@ -110,5 +110,5 @@
 	{
 		sprintf(str[i],"%s/Service_%03d",argv[1],i);
-		dis_add_service( str[i], "C", str[i], strlen(str[i])+1, 
+		dis_add_service( str[i], "C", str[i], (int)strlen(str[i])+1, 
 			(void *)0, 0 );
 	}
@@ -195,5 +195,5 @@
 				sprintf(more_str[curr_more_index],"%s/More_Service_%03d",argv[1],curr_more_index);
 				more_ids[curr_more_index] = dis_add_service( more_str[curr_more_index], "C", 
-					more_str[curr_more_index], strlen(more_str[curr_more_index])+1, 
+					more_str[curr_more_index], (int)strlen(more_str[curr_more_index])+1, 
 					(void *)0, 0 );
 printf("Adding service %s\n",more_str[curr_more_index]);
Index: trunk/FACT++/dim/src/examples/test_server.cxx
===================================================================
--- trunk/FACT++/dim/src/examples/test_server.cxx	(revision 14939)
+++ trunk/FACT++/dim/src/examples/test_server.cxx	(revision 15282)
@@ -168,5 +168,5 @@
 	if(testServ){}
 
-//	farr[0] = 1.2;
+	//	farr[0] = 1.2;
 //	farr[1] = 2.3;
 //	farrp = new DimService("/PCITCO147/sensors/fan/input","F", farr, sizeof(farr));
@@ -208,6 +208,6 @@
 		bool_serv[1]->updateService();
 		
-		int inCallback = DimServer::inCallback();
-		cout << "main: In callback "<< inCallback << endl; 
+//		int inCallback = DimServer::inCallback();
+//		cout << "main: In callback "<< inCallback << endl; 
 		servint.updateService();
 		if(extraDns)
Index: trunk/FACT++/dim/src/hash.c
===================================================================
--- trunk/FACT++/dim/src/hash.c	(revision 14939)
+++ trunk/FACT++/dim/src/hash.c	(revision 15282)
@@ -28,12 +28,12 @@
    int len;
 
-   len = strlen(name);
+   len = (int)strlen(name);
 
    for(i = 0; i < len; name++, i++)
    {
-      hash = hash*a+(*name);
+      hash = hash*a+(unsigned)(*name);
       a = a*b;
    }
 
-   return (hash % max);
+   return ((int)(hash % (unsigned)max));
 }
Index: trunk/FACT++/dim/src/open_dns.c
===================================================================
--- trunk/FACT++/dim/src/open_dns.c	(revision 14939)
+++ trunk/FACT++/dim/src/open_dns.c	(revision 15282)
@@ -156,5 +156,5 @@
 	get_proc_name(pid_str);
 	sscanf(pid_str,"%d",&pid);
-	srand(ip+pid);
+	srand((unsigned)(ip+pid));
 }
 
@@ -345,5 +345,5 @@
 			strcpy(node_info,dns_node);
 			for(i = 0; i < 4; i ++)
-				node_info[strlen(node_info)+i+1] = (char)0xff;
+				node_info[(int)strlen(node_info)+i+1] = (char)0xff;
 			connp->conn_id = 0;
 			connp->connecting = 1;
@@ -359,5 +359,5 @@
 		if(!conn_id)
 		{
-			strncpy(connp->task_name, DNS_TASK, MAX_TASK_NAME); 
+			strncpy(connp->task_name, DNS_TASK, (size_t)MAX_TASK_NAME); 
 			connp->recv_rout = recv_rout;
 			connp->error_rout = error_rout;
@@ -402,5 +402,5 @@
 			strcpy(node_info,dns_node);
 			for(i = 0; i < 4; i ++)
-				node_info[strlen(node_info)+i+1] = (char)0xff;
+				node_info[(int)strlen(node_info)+i+1] = (char)0xff;
 			connp->conn_id = 0;
 			connp->connecting = 1;
Index: trunk/FACT++/dim/src/sll.c
===================================================================
--- trunk/FACT++/dim/src/sll.c	(revision 14939)
+++ trunk/FACT++/dim/src/sll.c	(revision 15282)
@@ -38,5 +38,5 @@
 	while( (head = head->next) )
 	{
-		if( !memcmp(head->user_info, data, size) )
+		if( !memcmp(head->user_info, data, (size_t)size) )
 		{
 			break;
@@ -123,5 +123,5 @@
 	while( (auxp = item->next) )
 	{
-		if( !memcmp(&(auxp->user_info[offset]), data, size) )
+		if( !memcmp(&(auxp->user_info[offset]), data, (size_t)size) )
 		{
 			item->next = auxp->next;
Index: trunk/FACT++/dim/src/tcpip.c
===================================================================
--- trunk/FACT++/dim/src/tcpip.c	(revision 14939)
+++ trunk/FACT++/dim/src/tcpip.c	(revision 15282)
@@ -290,5 +290,5 @@
 		if(DIM_IO_path[0] == -1)
 		{
-			if( (DIM_IO_path[0] = socket(AF_INET, SOCK_STREAM, 0)) == -1 ) 
+			if( (DIM_IO_path[0] = (int)socket(AF_INET, SOCK_STREAM, 0)) == -1 ) 
 			{
 				perror("socket");
@@ -369,5 +369,5 @@
 		closesock(DIM_IO_path[0]);
 		DIM_IO_path[0] = -1;
-		if( (DIM_IO_path[0] = socket(AF_INET, SOCK_STREAM, 0)) == -1 ) 
+		if( (DIM_IO_path[0] = (int)socket(AF_INET, SOCK_STREAM, 0)) == -1 ) 
 		{
 			perror("socket");
@@ -568,5 +568,5 @@
 static int get_bytes_to_read(int conn_id)
 {
-	int i, ret, count;
+	int i, ret, count = 0;
 	
 	for(i = 0; i < 3; i++)
@@ -616,7 +616,7 @@
 		would this be better? not sure afterwards...
 		nbytes = (size < count) ? size : count;
-		if( (len = readsock(Net_conns[conn_id].channel, p, nbytes, 0)) <= 0 ) 
-*/
-		if( (len = readsock(Net_conns[conn_id].channel, p, size, 0)) <= 0 ) 
+		if( (len = readsock(Net_conns[conn_id].channel, p, (size_t)nbytes, 0)) <= 0 ) 
+*/
+		if( (len = (int)readsock(Net_conns[conn_id].channel, p, (size_t)size, 0)) <= 0 ) 
 		{	/* Connection closed by other side. */
 			Net_conns[conn_id].read_rout( conn_id, -1, 0 );
@@ -654,6 +654,6 @@
 
 	othersize = sizeof(other);
-	memset( (char *) &other, 0, othersize );
-	Net_conns[conn_id].mbx_channel = accept( Net_conns[conn_id].channel,
+	memset( (char *) &other, 0, (size_t)othersize );
+	Net_conns[conn_id].mbx_channel = (int)accept( Net_conns[conn_id].channel,
 						 (struct sockaddr*)&other, (unsigned int *)&othersize );
 	if( Net_conns[conn_id].mbx_channel < 0 ) 
@@ -842,5 +842,5 @@
 int ret;
 
-	ptr = (unsigned char *)node+strlen(node)+1;
+	ptr = (unsigned char *)node+(int)strlen(node)+1;
     ipaddr[0] = *ptr++;
     ipaddr[1] = *ptr++;
@@ -900,8 +900,8 @@
 	{
 		sscanf(node,"%d.%d.%d.%d",&a, &b, &c, &d);
-	    ipaddr[0] = a;
-	    ipaddr[1] = b;
-	    ipaddr[2] = c;
-	    ipaddr[3] = d;
+	    ipaddr[0] = (unsigned char)a;
+	    ipaddr[1] = (unsigned char)b;
+	    ipaddr[2] = (unsigned char)c;
+	    ipaddr[3] = (unsigned char)d;
 	    host_number = 1;
 #ifndef VxWorks
@@ -928,5 +928,5 @@
 		host_number = 1;
 /*
-          ptr = (unsigned char *)node+strlen(node)+1;
+          ptr = (unsigned char *)node+(int)strlen(node)+1;
           ipaddr[0] = *ptr++;
           ipaddr[1] = *ptr++;
@@ -961,5 +961,5 @@
 #endif
 
-	if( (path = socket(AF_INET, SOCK_STREAM, 0)) == -1 ) 
+	if( (path = (int)socket(AF_INET, SOCK_STREAM, 0)) == -1 ) 
 	{
 		perror("socket");
@@ -1053,5 +1053,5 @@
 
     dim_tcpip_init(0);
-	if( (path = socket(AF_INET, SOCK_STREAM, 0)) == -1 ) 
+	if( (path = (int)socket(AF_INET, SOCK_STREAM, 0)) == -1 ) 
 	{
 		return(0);
@@ -1257,5 +1257,5 @@
 	int	wrote;
 
-	wrote = writesock( Net_conns[conn_id].channel, buffer, size, 0 );
+	wrote = (int)writesock( Net_conns[conn_id].channel, buffer, (size_t)size, 0 );
 	if( wrote == -1 ) {
 /*
@@ -1306,5 +1306,5 @@
 	
 	set_non_blocking(Net_conns[conn_id].channel);
-	wrote = writesock( Net_conns[conn_id].channel, buffer, size, 0 );
+	wrote = (int)writesock( Net_conns[conn_id].channel, buffer, (size_t)size, 0 );
 #ifndef WIN32
 	ret = errno;
@@ -1332,5 +1332,5 @@
 			if(selret > 0)
 			{
-				wrote = writesock( Net_conns[conn_id].channel, buffer, size, 0 );
+				wrote = (int)writesock( Net_conns[conn_id].channel, buffer, (size_t)size, 0 );
 				if( wrote == -1 ) 
 				{
Index: trunk/FACT++/dim/src/tokenstring.cxx
===================================================================
--- trunk/FACT++/dim/src/tokenstring.cxx	(revision 14939)
+++ trunk/FACT++/dim/src/tokenstring.cxx	(revision 15282)
@@ -4,5 +4,5 @@
 TokenString::TokenString(char *str)
 {
-	token_buff = new char[(strlen(str)+1)*2];
+	token_buff = new char[((int)strlen(str)+1)*2];
 	token_ptr = token_buff;
 	token_seps = 0;
@@ -14,7 +14,7 @@
 TokenString::TokenString(char *str, char *seps)
 {
-	token_buff = new char[(strlen(str)+1)*2];
-	token_ptr = token_buff;
-	token_seps = new char[(strlen(seps)+1)];
+	token_buff = new char[((int)strlen(str)+1)*2];
+	token_ptr = token_buff;
+	token_seps = new char[((int)strlen(seps)+1)];
 	strcpy(token_seps,seps);
 	store_str(str);
@@ -154,5 +154,5 @@
 
 	curr_token_ptr = token_ptr;
-    token_ptr += strlen(curr_token_ptr)+1;
+    token_ptr += (int)strlen(curr_token_ptr)+1;
 	token = curr_token_ptr;
 
Index: trunk/FACT++/dim/src/util/dim_send_command.c
===================================================================
--- trunk/FACT++/dim/src/util/dim_send_command.c	(revision 14939)
+++ trunk/FACT++/dim/src/util/dim_send_command.c	(revision 15282)
@@ -61,5 +61,5 @@
 		}
 	}
-	dic_cmnd_callback(str,data,strlen(data)+1, rout, silent);
+	dic_cmnd_callback(str,data,(int)strlen(data)+1, rout, silent);
 	while(!received)
 	  dim_wait();
@@ -135,5 +135,5 @@
 	else
 	{
-		dic_cmnd_callback(str,data,strlen(data)+1, rout, silent);
+		dic_cmnd_callback(str,data,(int)strlen(data)+1, rout, silent);
 	}
 	while(!received)
Index: trunk/FACT++/dim/src/utilities.c
===================================================================
--- trunk/FACT++/dim/src/utilities.c	(revision 14939)
+++ trunk/FACT++/dim/src/utilities.c	(revision 15282)
@@ -102,5 +102,5 @@
 #endif
 char node_name[MAX_NODE_NAME];
-unsigned char *ptr;
+char *ptr;
 
 #ifdef WIN32
@@ -117,5 +117,5 @@
 		return(0);
 	}
-    ptr = (unsigned char *)host->h_addr;
+    ptr = (char *)host->h_addr;
     node_addr[0] = *ptr++;
     node_addr[1] = *ptr++;
@@ -150,5 +150,5 @@
 */
 	my_ctime(&t, str, 128);
-	str[strlen(str)-1] = '\0';
+	str[(int)strlen(str)-1] = '\0';
 	printf("PID %d - ",getpid());
 	printf("%s - ",str );
@@ -172,5 +172,5 @@
 	tz = 0;
 	gettimeofday(&tv, tz);
-	millies = tv.tv_usec / 1000;
+	millies = (int)tv.tv_usec / 1000;
 #endif
 	dim_print_date_time();
@@ -233,5 +233,5 @@
 		return(0);
 	else {
-		tot = strlen(p)+1;
+		tot = (int)strlen(p)+1;
 		if(value != 0)
 		{
@@ -239,5 +239,5 @@
 			if(sz > len)
 				sz = len;
-			strncpy(value, p, sz);
+			strncpy(value, p, (size_t)sz);
 			if((sz == len) && (len > 0))
 				value[sz-1] = '\0';
Index: trunk/FACT++/dim/src/webDid/webDid.c
===================================================================
--- trunk/FACT++/dim/src/webDid/webDid.c	(revision 14939)
+++ trunk/FACT++/dim/src/webDid/webDid.c	(revision 15282)
@@ -15,4 +15,5 @@
 	int match;
 	int busy;
+	int isSMI;
 }SERVER;
 
@@ -23,4 +24,5 @@
 	int match;
 	int busy;
+	int hasSMI;
 }NODE;
 NODE *Node_head = (NODE *)0;
@@ -319,5 +321,5 @@
 			buffer->services[j].n_clients = vtohl(
 				buffer->services[j].n_clients);
-			if(strlen(sname) == MAX_TASK_NAME-4-1)
+			if((int)strlen(sname) == MAX_TASK_NAME-4-1)
 			{
 				strcpy(str,buffer->services[j].name);
@@ -337,4 +339,5 @@
 			nodep = (NODE *)malloc(sizeof(NODE));
 			strcpy(nodep->name,buffer->server.node);
+			nodep->hasSMI = 0;
 			nodep->server_head = (SERVER *)malloc(sizeof(SERVER));
 			sll_init((SLL *)nodep->server_head);
@@ -352,4 +355,10 @@
 			servp->server.n_services = 0;
 			servp->service_ptr = 0;
+			servp->isSMI = 0;
+			if(strstr(sname,"_SMI"))
+			{
+				servp->isSMI = 1;
+				nodep->hasSMI = 1;
+			}
 			sll_insert_queue((SLL *)nodep->server_head,(SLL *)servp);
 		}
@@ -373,7 +382,7 @@
 		if(n_services != -1)
 		{
-			service_size = n_services*sizeof(DNS_SERVICE_INFO);
-			servp->service_ptr = (DNS_SERVICE_INFO *)malloc(service_size);
-			memcpy(servp->service_ptr, buffer->services, service_size);
+			service_size = n_services*(int)sizeof(DNS_SERVICE_INFO);
+			servp->service_ptr = (DNS_SERVICE_INFO *)malloc((size_t)service_size);
+			memcpy(servp->service_ptr, buffer->services, (size_t)service_size);
 			N_services += n_services;
 		}
@@ -391,4 +400,5 @@
 		servp->server.n_services = 0;
 		servp->busy = -1;
+		servp->isSMI = 0;
 	    }
 	}
@@ -464,15 +474,15 @@
 		if(!rpc_flag)
 		{
-		    ptr += strlen(str);
+		    ptr += (int)strlen(str);
 		    ptr1 = strchr(ptr,'|');
 		}
 		else if(rpc_flag == 1)
 		{
-		    ptr += strlen(str);
+		    ptr += (int)strlen(str);
 		    ptr1 = strchr(ptr,',');
 		}
 		else
 		{
-		    ptr += strlen(str);
+		    ptr += (int)strlen(str);
 		    ptr = strchr(ptr,',');
 		    ptr++;
@@ -512,20 +522,20 @@
 		if(!rpc_flag)
 		{
-		    ptr += strlen(str);
+		    ptr += (int)strlen(str);
 		    ptr1 = strchr(ptr,'|');
 		}
 		else if(rpc_flag == 1)
 		{
-		    ptr += strlen(str);
+		    ptr += (int)strlen(str);
 		    ptr1 = strchr(ptr,',');
 		}
 		else
 		{
-		    ptr += strlen(str);
+		    ptr += (int)strlen(str);
 		    ptr = strchr(ptr,',');
 		    ptr++;
 		    ptr1 = strchr(ptr,'|');
 		}
-	    strncpy(format,ptr,(int)(ptr1 - ptr));
+	    strncpy(format,ptr,(size_t)(ptr1 - ptr));
 	    format[(int)(ptr1-ptr)] = '\0';
 	}
@@ -678,5 +688,5 @@
 		servicep->n_browsers = 0;
 		sll_insert_queue((SLL *)Curr_service_head,(SLL *)servicep);
-		servicep->sid = dic_info_service_stamped( service, MONITORED, subscribe, 0, 0,
+		servicep->sid = (int)dic_info_service_stamped( service, MONITORED, subscribe, 0, 0,
 			recv_service_info, servicep, &no_link_int, 4);
 	}
@@ -792,8 +802,8 @@
 		if(servicep->buffer_size)
 			free(servicep->buffer);
-		servicep->buffer = malloc(*size);
+		servicep->buffer = malloc((size_t)*size);
 		servicep->buffer_size = *size;
 	}
-	memcpy(servicep->buffer, (char *)buffer, *size);
+	memcpy(servicep->buffer, (char *)buffer, (size_t)*size);
 	servicep->size = *size;
 	if (servicep->buffer_str_size < (1024 + (*size)*16))
@@ -801,5 +811,5 @@
 		if(servicep->buffer_str_size)
 			free(servicep->buffer_str);
-		servicep->buffer_str = malloc(1024 + (*size)*16);
+		servicep->buffer_str = malloc((size_t)(1024 + (*size)*16));
 		servicep->buffer_str_size = 1024 + (*size)*16;
 	}
@@ -855,5 +865,5 @@
     sprintf(ptr,".%03d",mili);
     strcat(timestr, aux);
-    timestr[strlen(timestr)-1] = '\0';
+    timestr[(int)strlen(timestr)-1] = '\0';
    
     sprintf(str," Timestamp: %s&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp Quality: %d&nbsp&nbsp&nbsp Size: %s<br /><br />",
@@ -906,8 +916,8 @@
       strcat(Service_content_str," L");
       if(!num)
-		size = ssize/sizeof(int);
+		size = ssize/(int)sizeof(int);
       else
 		size = num;
-      psize = size * sizeof(int);
+      psize = size * (int)sizeof(int);
       print_service_standard(ptr, size);
       break;
@@ -916,8 +926,8 @@
       strcat(Service_content_str," I");
       if(!num)
-		size = ssize/sizeof(int);
+		size = ssize/(int)sizeof(int);
       else
 		size = num;
-      psize = size * sizeof(int);
+      psize = size * (int)sizeof(int);
       print_service_standard(ptr, size);
       break;
@@ -926,8 +936,8 @@
       strcat(Service_content_str," S");
       if(!num)
-		size = ssize/sizeof(short);
+		size = ssize/(int)sizeof(short);
       else
 		size = num;
-      psize = size * sizeof(short);
+      psize = size * (int)sizeof(short);
       print_service_short(ptr, size);
       break;
@@ -936,8 +946,8 @@
       strcat(Service_content_str," F");
       if(!num)
-		size = ssize/sizeof(float);
+		size = ssize/(int)sizeof(float);
       else
 		size = num;
-      psize = size * sizeof(float);
+      psize = size * (int)sizeof(float);
       print_service_float(ptr, size);
       break;
@@ -946,8 +956,8 @@
       strcat(Service_content_str," D");
       if(!num)
-		size = ssize/sizeof(double);
+		size = ssize/(int)sizeof(double);
       else
 		size = num;
-      psize = size * sizeof(double);
+      psize = size * (int)sizeof(double);
       print_service_double(ptr, size);
       break;
@@ -956,8 +966,8 @@
       strcat(Service_content_str," X");
       if(!num)
-		size = ssize/sizeof(longlong);
+		size = ssize/(int)sizeof(longlong);
       else
 		size = num;
-      psize = size * sizeof(longlong);
+      psize = size * (int)sizeof(longlong);
       print_service_standard(ptr, size*2);
       break;
@@ -999,5 +1009,5 @@
 
 	ptr = Service_content_str;
-	ptr += strlen(Service_content_str);
+	ptr += (int)strlen(Service_content_str);
 	for( i = 0; i < size; i++)
 	{
@@ -1030,5 +1040,5 @@
 		}
 		strcpy(ptr, tmp);
-		ptr += strlen(tmp);
+		ptr += (int)strlen(tmp);
 	}
 	strcpy(tmp,"<br />");
@@ -1043,5 +1053,5 @@
 
 	ptr = Service_content_str;
-	ptr += strlen(Service_content_str);
+	ptr += (int)strlen(Service_content_str);
 	for( i = 0; i < size; i++)
 	{
@@ -1068,5 +1078,5 @@
 				if(j == 0)
 					strcat(tmp,"&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp D: ");
-				sprintf_html(str, 12, last[j]);
+				sprintf_html(str, 12, (int)last[j]);
 				strcat(tmp,str);
 			}
@@ -1074,5 +1084,5 @@
 		}
 		strcpy(ptr, tmp);
-		ptr += strlen(tmp);
+		ptr += (int)strlen(tmp);
 	}
 	strcpy(tmp,"<br />");
@@ -1087,5 +1097,5 @@
 
 	ptr = Service_content_str;
-	ptr += strlen(Service_content_str);
+	ptr += (int)strlen(Service_content_str);
 	for( i = 0; i < size; i++)
 	{
@@ -1118,5 +1128,5 @@
 		}
 		strcpy(ptr, tmp);
-		ptr += strlen(tmp);
+		ptr += (int)strlen(tmp);
 	}
 	strcpy(tmp,"<br />");
@@ -1131,5 +1141,5 @@
 	asc = (char *)buff;
 	ptr = Service_content_str;
-	ptr += strlen(Service_content_str);
+	ptr += (int)strlen(Service_content_str);
 	for( i = 0; i < size; i++)
 	{
@@ -1150,5 +1160,5 @@
 */
 		strcat(tmp," ");
-		strcat(tmp,&str[strlen(str)-2]);
+		strcat(tmp,&str[(int)strlen(str)-2]);
 		/*
 		if(i%4 == 3)
@@ -1180,5 +1190,5 @@
 		}
 		strcpy(ptr, tmp);
-		ptr += strlen(tmp);
+		ptr += (int)strlen(tmp);
 	}
 	strcpy(tmp,"<br />");
@@ -1192,5 +1202,5 @@
 
 	ptr = Service_content_str;
-	ptr += strlen(Service_content_str);
+	ptr += (int)strlen(Service_content_str);
 	for( i = 0; i < size; i++)
 	{
@@ -1212,9 +1222,9 @@
 		}
 		strcpy(ptr, tmp);
-		ptr += strlen(tmp);
+		ptr += (int)strlen(tmp);
 	}
 	strcpy(tmp,"<br />");
 	strcpy(ptr, tmp);
-	ptr += strlen(tmp);
+	ptr += (int)strlen(tmp);
 }
 
@@ -1225,5 +1235,5 @@
 
     ptr = Service_content_str;
-	ptr += strlen(Service_content_str);
+	ptr += (int)strlen(Service_content_str);
 	for( i = 0; i < size; i++)
 	{
@@ -1245,9 +1255,9 @@
 		}
 		strcpy(ptr, tmp);
-		ptr += strlen(tmp);
+		ptr += (int)strlen(tmp);
 	}
 	strcpy(tmp,"<br />");
 	strcpy(ptr, tmp);
-	ptr += strlen(tmp);
+	ptr += (int)strlen(tmp);
 }
 
@@ -1257,5 +1267,5 @@
 
 	strcat(ptr,"{\n");
-	ptro = ptr + strlen(ptr);
+	ptro = ptr + (int)strlen(ptr);
 	return ptro;
 }
@@ -1266,5 +1276,5 @@
 
 	strcat(ptr,"}\n");
-	ptro = ptr + strlen(ptr);
+	ptro = ptr + (int)strlen(ptr);
 	return ptro;
 }
@@ -1275,5 +1285,5 @@
 
 	sprintf(ptr,"%s: [\n", node);
-	ptro = ptr + strlen(ptr);
+	ptro = ptr + (int)strlen(ptr);
 	return ptro;
 }
@@ -1284,5 +1294,5 @@
 
 	strcat(ptr,"]\n");
-	ptro = ptr + strlen(ptr);
+	ptro = ptr + (int)strlen(ptr);
 	return ptro;
 }
@@ -1296,5 +1306,5 @@
 	else
 		sprintf(ptr,"{ %s", child);
-	ptro = ptr + strlen(ptr);
+	ptro = ptr + (int)strlen(ptr);
 	return ptro;
 }
@@ -1308,5 +1318,5 @@
 	else
 		strcat(ptr," }\n");
-	ptro = ptr + strlen(ptr);
+	ptro = ptr + (int)strlen(ptr);
 	return ptro;
 }
@@ -1352,5 +1362,5 @@
 	for(i = 0; i < ((int)strlen(label) + 1); i++)
 	{
-		label[i] = tolower(label[i]);
+		label[i] = (char)tolower((int)label[i]);
 		if(label[i] == '.')
 		{
@@ -1384,10 +1394,10 @@
 		if(JSONBufferSize == 0)
 		{
-			JSONBuffer = malloc(N_nodes*128+N_servers*128);
+			JSONBuffer = malloc((size_t)(N_nodes*128+N_servers*128));
 		}
 		else if (JSONBufferSize < N_nodes*128+N_servers*128)
 		{
 			free(JSONBuffer);
-			JSONBuffer = malloc(N_nodes*128+N_servers*128);
+			JSONBuffer = malloc((size_t)(N_nodes*128+N_servers*128));
 		}
 		ptr = JSONBuffer;
@@ -1397,10 +1407,10 @@
 		if(browserp->JSONBufferSize == 0)
 		{
-			browserp->JSONBuffer = malloc(N_nodes*128+N_servers*128);
+			browserp->JSONBuffer = malloc((size_t)(N_nodes*128+N_servers*128));
 		}
 		else if (browserp->JSONBufferSize < N_nodes*128+N_servers*128)
 		{
 			free(browserp->JSONBuffer);
-			browserp->JSONBuffer = malloc(N_nodes*128+N_servers*128);
+			browserp->JSONBuffer = malloc((size_t)(N_nodes*128+N_servers*128));
 		}
 		ptr = browserp->JSONBuffer;
@@ -1556,10 +1566,10 @@
 	if(JSONServicesSize == 0)
 	{
-		JSONServices = malloc(n_services*256);
+		JSONServices = malloc((size_t)(n_services*256));
 	}
 	else if (JSONServicesSize < n_services*256)
 	{
 		free(JSONServices);
-		JSONServices = malloc(n_services*256);
+		JSONServices = malloc((size_t)(n_services*256));
 	}
 	if(browserp)
@@ -1704,8 +1714,8 @@
       if(last_size)
 		free(last_buffer);
-      last_buffer = malloc(full_size);
+      last_buffer = malloc((size_t)full_size);
       last_size = full_size;
    }
-   memset(last_buffer, 0, last_size);
+   memset(last_buffer, 0, (size_t)last_size);
    buffer_ptr = last_buffer;
    ptr = format; 
@@ -1864,6 +1874,6 @@
 			strp++;
 		}
-		num = strlen(strp)+1;
-		strncpy((char *)ptr,strp,num);
+		num = (int)strlen(strp)+1;
+		strncpy((char *)ptr,strp,(size_t)num);
 		if( (ptr1 = (char *)strchr((char *)ptr,'\"')) )
 		{
Index: trunk/FACT++/dim/src/webDid/webServer.c
===================================================================
--- trunk/FACT++/dim/src/webDid/webServer.c	(revision 14939)
+++ trunk/FACT++/dim/src/webDid/webServer.c	(revision 15282)
@@ -68,6 +68,6 @@
 	(void)sprintf(snd_buffer,"HTTP/1.1 200 OK\r\nDate: %s\r\nServer: DID/19.7\r\nContent-Length: %d\r\nContent-Type: %s\r\nConnection: close\r\n\r\n",
 		      date_buffer, (int)strlen(logbuffer), "text/html");
-    (void)web_write(conn_id,snd_buffer,strlen(snd_buffer));
-                (void)web_write(conn_id,logbuffer,strlen(logbuffer));
+    (void)web_write(conn_id,snd_buffer,(int)strlen(snd_buffer));
+                (void)web_write(conn_id,logbuffer,(int)strlen(logbuffer));
                 break;
         case LOG: (void)printf("INFO: %s:%s:%d\n",s1, s2,conn_id); 
@@ -98,5 +98,5 @@
 		if((ptr = strstr(buffer, parptr)))
 		{
-			ptrs[i] = ptr+strlen(parptr);
+			ptrs[i] = ptr+(int)strlen(parptr);
 			found++;
 		}
@@ -206,10 +206,10 @@
   int code;
 
-  buffer_size = strlen(buffer) + 1;
+  buffer_size = (int)strlen(buffer) + 1;
   if(buffer_size > conv_buffer_size )
   {
     if(conv_buffer_size)
       free(conv_buffer);
-    conv_buffer = malloc(buffer_size);
+    conv_buffer = malloc((size_t)buffer_size);
     conv_buffer_size = buffer_size;
   }
@@ -333,8 +333,112 @@
 	(void)sprintf(snd_buffer,"HTTP/1.1 200 OK\r\nDate: %s\r\nServer: DID/19.7\r\nContent-Length: %d\r\nContent-Type: %s\r\nConnection: close\r\n\r\n",
 		      date_buffer, (int)strlen(ptr), datatype);
-    (void)web_write(conn_id,snd_buffer,strlen(snd_buffer));
+    (void)web_write(conn_id,snd_buffer,(int)strlen(snd_buffer));
 if(WebDID_Debug)
 	printf("SENDING DATA to conn %d:\n%s\n",conn_id, snd_buffer);
-    (void)web_write(conn_id,ptr,strlen(ptr));
+    (void)web_write(conn_id,ptr,(int)strlen(ptr));
+if(WebDID_Debug == 2)
+	printf("SENDING DATA to conn %d:\n%s\n",conn_id, ptr);
+}
+
+
+void sendSmiData(int conn_id, char *buffer, int type)
+{
+	static char date_buffer[128];
+	static char snd_buffer[BUFSIZE+1]; /* static so zero filled */
+	static char snd_data_buffer[BUFSIZE+1]; /* static so zero filled */
+	char *ptr = 0;
+	char node[128], server[256], service[256];
+	int pid, ret, req, browser, force;
+	extern char *update_services();
+	extern char *update_service_data();
+	extern char *getJSONHeader();
+	extern char *getJSONBuffer();
+	char datatype[128];
+	char *conv_buffer;
+
+	conv_buffer = buffer;
+	strcpy(datatype,"application/json");
+	if(type == 0)
+	{
+	  ptr = getJSONHeader();
+	}
+	else if(type == 1)
+	{
+	    ret = getNodeParameters(conv_buffer, node, &browser);
+		ptr = getJSONBuffer(node, browser);
+	}
+	else if(type == 2)
+	{
+		ret = getServerParameters(conv_buffer, node, server, &pid, &browser);
+		if(!ret)
+		{
+			strcpy(snd_data_buffer,"{}");
+			ptr = snd_data_buffer;
+		}
+		else
+		{
+			ptr = update_services(node, server, pid, browser);
+		}
+	}
+	else if(type == 3)
+	{
+		ret = getServiceParameters(conv_buffer, service, &req, &browser, &force);
+		if(!ret)
+		{
+			strcpy(snd_data_buffer,"{}");
+			ptr = snd_data_buffer;
+		}
+		else
+		{
+			update_service_data(service, conn_id, 0, req, browser, force);
+			return;
+		}
+	}
+	else if(type == 4)
+	{
+		ptr = conv_buffer;
+if(WebDID_Debug)
+		printf("%s\n",ptr);
+		strcpy(datatype,"text/html");
+	}
+	else if(type == 5)
+	{
+		ret = getServiceParameters(conv_buffer, service, &req, &browser, &force);
+		if(!ret)
+		{
+			strcpy(snd_data_buffer,"{}");
+			ptr = snd_data_buffer;
+		}
+		else
+		{
+			check_browser_changes(service, conn_id, 0, req, browser, force);
+			return;
+		}
+	}
+	else if(type == 6)
+	{
+		ret = getServiceParameters(conv_buffer, service, &req, &browser, &force);
+		if(!ret)
+		{
+			strcpy(snd_data_buffer,"{}");
+			ptr = snd_data_buffer;
+		}
+		else
+		{
+			find_services(service, conn_id, browser, force);
+			if(force == -1)
+				strcpy(snd_data_buffer,"");
+			else
+				strcpy(snd_data_buffer,"load");
+			ptr = snd_data_buffer;
+		}
+	}
+	getTime(date_buffer);
+	(void)sprintf(snd_buffer,"HTTP/1.1 200 OK\r\nDate: %s\r\nServer: DID/19.7\r\nContent-Length: %d\r\nContent-Type: %s\r\nConnection: close\r\n\r\n",
+		      date_buffer, (int)strlen(ptr), datatype);
+    (void)web_write(conn_id,snd_buffer,(int)strlen(snd_buffer));
+if(WebDID_Debug)
+	printf("SENDING DATA to conn %d:\n%s\n",conn_id, snd_buffer);
+    (void)web_write(conn_id,ptr,(int)strlen(ptr));
 if(WebDID_Debug == 2)
 	printf("SENDING DATA to conn %d:\n%s\n",conn_id, ptr);
@@ -356,4 +460,6 @@
         else buffer[0]=0;
 
+if(WebDID_Debug)
+printf("Got %s\n", buffer);
         if( strncmp(buffer,"GET ",4) && strncmp(buffer,"get ",4) )
 		{
@@ -371,5 +477,7 @@
         }
 
-        for(j=0;j<i-1;j++)      /* check for illegal parent directory use .. */
+if(WebDID_Debug)
+printf("Got 1 %s\n", buffer);
+       for(j=0;j<i-1;j++)      /* check for illegal parent directory use .. */
 		{
                 if(buffer[j] == '.' && buffer[j+1] == '.')
@@ -379,15 +487,23 @@
 				}
 		}
-        if( !strncmp(&buffer[0],"GET /\0",6) || !strncmp(&buffer[0],"get /\0",6) ) 
+		if((int)strlen(buffer) == 5)
+		{
+			if( !strncmp(&buffer[0],"GET /",5) || !strncmp(&buffer[0],"get /",5) ) 
 			/* convert no filename to index file */
                 (void)strcpy(buffer,"GET /index.html");
-
+		}
+		if((int)strlen(buffer) == 8)
+		{
+			if( !strncmp(&buffer[0],"GET /smi",8) || !strncmp(&buffer[0],"get /smi",8) ) 
+			/* convert no filename to index file */
+                (void)strcpy(buffer,"GET /smi/index.html");
+		}
         /* work out the file type and check we support it */
-        buflen=strlen(buffer);
+        buflen=(int)strlen(buffer);
         fstr = (char *)0;
         for(i=0;extensions[i].ext != 0;i++) 
 		{
-              len = strlen(extensions[i].ext);
-              if( !strncmp(&buffer[buflen-len], extensions[i].ext, len)) 
+              len = (int)strlen(extensions[i].ext);
+              if( !strncmp(&buffer[buflen-len], extensions[i].ext, (size_t)len)) 
 			  {
                         fstr =extensions[i].filetype;
@@ -397,5 +513,5 @@
 /*
 		(void)sprintf(snd_buffer,"HTTP/1.1 100 Continue\r\n\r\n");
-        (void)web_write(conn_id,snd_buffer,strlen(snd_buffer));
+        (void)web_write(conn_id,snd_buffer,(int)strlen(snd_buffer));
 		printf("SENDING to conn %d:\n%s\n",conn_id, snd_buffer);
 */
@@ -432,4 +548,9 @@
 			{
 				sendData(conn_id, &buffer[5], 6);
+				return;
+			}
+			else if(!strncmp(&buffer[5],"smiObjects",11))
+			{
+				sendSmiData(conn_id, &buffer[5], 2);
 				return;
 			}
@@ -441,8 +562,8 @@
 					*ptr = '\0';
 				}
-				buflen=strlen(buffer);
+				buflen=(int)strlen(buffer);
 				for(i=0;extensions[i].ext != 0;i++) 
 				{
-					len = strlen(extensions[i].ext);
+					len = (int)strlen(extensions[i].ext);
 					if( !strncmp(&buffer[buflen-len], extensions[i].ext, len)) 
 					{
@@ -476,5 +597,5 @@
 
 		flen = 0;
-        while ( (ret = read(file_fd, snd_buffer, BUFSIZE)) > 0 ) 
+        while ( (ret = (int)read(file_fd, snd_buffer, BUFSIZE)) > 0 ) 
 		{
 			flen += ret;
@@ -491,10 +612,10 @@
 		(void)sprintf(snd_buffer,"HTTP/1.1 200 OK\r\nDate: %s\r\nServer: DID/19.7\r\nContent-Length: %d\r\nContent-Type: %s\r\nConnection: close\r\n\r\n",
             date_buffer, flen, fstr);
-        (void)web_write(conn_id,snd_buffer,strlen(snd_buffer));
+        (void)web_write(conn_id,snd_buffer,(int)strlen(snd_buffer));
 if(WebDID_Debug)
 		printf("SENDING to conn %d:\n%s\n",conn_id, snd_buffer);
 
         /* send file in 8KB block - last block may be smaller */
-        while ( (ret = read(file_fd, snd_buffer, BUFSIZE)) > 0 ) {
+        while ( (ret = (int)read(file_fd, snd_buffer, BUFSIZE)) > 0 ) {
                 (void)web_write(conn_id,snd_buffer,ret);
 if(WebDID_Debug == 2)
